

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII       MOBILE ROBOT C-CONTROL II GATEWAY          IIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'
'Dieses Beispiel ladet einen neuen Treiber in das EEprom des Microcontrollers.
'Der Treiber untersttzt den Betrieb der Basiserweiterung (in diesem Fall die
'Ansteuerung der 8 LEDs welche die Basiserweiterung zur Verfgung stellt)
'Ausserdem stellt das Programm spezielle Routinen fr den Zugriff der C-Control II
'Unit auf die Systemresourcen des CCRP5 sicher
'
'This sample loads a new driver into the EEPROM of the microcontroller.
'The driver supports the operation of the Base Extension (in this case
'it drives the 8 LEDs on the Base Extension).
'Additionally the driver supports the access to the CCRP5 harware when
'you use a C-Control II Unit as main processor. 
'
'---------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
'- INTERFACE LCD/EXTPORT --
define sdio         port[1]
define sclio        port[3]
define strobe       port[4]
define LSTROBE      port[7]
'-- INTERFACE COM/NAV -----
define DATALINE     port[1]
define CLOCKLINE    port[2]
'-- CC2 INTERFACE   -------
define CC2POWER     port[8]
define NAVSTART     port[16]
'--------------------------
'------ SENSORS ---------
'--------------------------
define LIGHT_L      ad[7]
define LIGHT_R      ad[6]
define SYS_VOLTS    ad[3]
define CHRG_CURRENT ad[2]
define SYS_CURRENT  ad[1]
define MIC          ad[4]
define TOUCH        ad[5]
'---------------------------
'------  DRIVE -------------
'---------------------------
define SPEED_L        da[1]
define SPEED_R        da[2]
define REV_L        port[6]
define REV_R        port[5]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
'--- INTERFACE BUFFER ----
define LBYTE         byte[1]
define HBYTE         byte[2]
define SUBCMD        byte[3]
'---- OPERATION DATA ------
define EXTPORT       byte[4]
define LED1_F        bit[29]
define LED2_F        bit[30]
define LED3_F        bit[31]
define LED4_F        bit[32]
define SYSTEM_STATUS byte[5]
define LEDPORT       byte[6]
define L1_F          bit[41]
define L2_F          bit[42]
define L3_F          bit[43]
define L4_F          bit[44]
define L5_F          bit[45]
define L6_F          bit[46]
define L7_F          bit[47]
define L8_F          bit[48]
'--------------------------
'----  USER MEMORY  -------
'--------------------------
define CID           byte[7]
define GPR           byte[8]
define SEC           byte[9]
define MIN           byte[10]
define HR            byte[11]
define OLDSEC        byte[12]
define INWORD        word[12]
define READY         0
'--- SYSTEMROUTINEN -----------
define PLM_SLOW      &H01C2
define SYSTEM        &H01C7
define LED_DRIVE     &H01CA
define COMNAV        &H0144
'- ERWEITERTE SYSTEM ROUTINEN -
define REVR          &H0101   'ANTRIEB RECHTS RCKWRTS
define REVL          &H0106   'ANTRIEB LINKS RCKWRTS
define FWDR          &H010B   'ANTRIEG RECHTS VORWRTS
define FWDL          &H0110   'ANTRIEB LINKS VORWRTS
define ROTR          &H0115   'RECHTS DREHEN
define ROTL          &H0119   'LINKS DREHEN
define REV           &H011D   'RCKWRTS
define FWD           &H0121   'VORWRTS
define COMNAV_STATUS &H0125   'UPDATED ALLE FLAGS IM STATUS-REGISTER
define ACS_LO        &H01E0   'ACS POWER LO
define ACS_HI        &H01E8   '
define ACS_MAX       &H01F0   '
define SEND_TLM      &H013A   'SENDET TELEMETRIE (CH=HBYTE,DATEN=LBYTE)
define SEND_SYSSTAT  &H0134   'SENDET TLM KANAL 0,SYSTEM STATUS
                              '(FLAGS fr ACS,FWD/REV, ACS_LO/HI/MAX)

'---------- SUBSYS POWER ON--------------
gosub SUBSYS_PWR_ON:
'---------- CC2 POWER ON ----------------
CC2POWER=on
'------- POSITIONING SYSTEM START -------
NAVSTART=off
'---------  DRIVE INIT ------------------
REV_L=off:REV_R=off:SYS PLM_SLOW
'-----------   LEDs INIT   --------------
EXTPORT=EXTPORT and &H0F:SYS SYSTEM:pulse STROBE
LEDPORT=0:SYS LED_DRIVE:pulse LSTROBE
'-------  SERIAL INTERFACE INIT  --------
#FLUSH
if not RXD then goto START
get CID:goto FLUSH
'HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
'HHHHHHHHHHHHHHHH  GATEWAY COMMAND INTERPRETER  HHHHHHHHHHHHHHHHHH
'HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
#START
SUBCMD=3:sys COMNAV ' green LED flash

#LOOP
if not RXD then goto LOOP
get CID
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
if CID>4 then goto BLOCK2
if CID=0 then goto C0
if CID=1 then goto C1
if CID=2 then goto C2
if CID=3 then goto C3
if CID=4 then goto C4
#BLOCK2
if CID=5 then goto C5
if CID=6 then goto C6
if CID=7 then goto C7
if CID=8 then goto C8
if CID=9 then goto C9
if CID=10 then goto C10
#BLOCK3
if CID=11 then goto C11
if CID=12 then goto C12
if CID=13 then goto C13
if CID=14 then goto C14
if CID=15 then goto C15
#BLOCK4
if CID=16 then goto C16
if CID=17 then goto C17
if CID=18 then goto C18
if CID=19 then goto C19
if CID=20 then goto C20
goto LOOP

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIII COMMNAV STATUS ACCESS IIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C0
SYS COMNAV_STATUS:put SYSTEM_STATUS:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII     DRIVE COMMANDS          IIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C1
get SPEED_L:get SPEED_R:SYS FWD:put READY:goto LOOP
#C2
get SPEED_L:get SPEED_R:SYS REV:put READY:goto LOOP
#C3
get SPEED_L:get SPEED_R:SYS ROTL:put READY:goto LOOP
#C4
get SPEED_L:get SPEED_R:SYS ROTR:PUT READY:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIII      SENSOR ACCESS              IIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C5'  AMBIENT SENSOR DATA
get CID:if CID=1 then goto C5x
put LIGHT_L:put LIGHT_R:put MIC:put TOUCH:goto LOOP
#C5x
SUBCMD=6:sys COMNAV:put HBYTE:put LBYTE
SUBCMD=7:sys COMNAV:put HBYTE:put LBYTE:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII     ACS ACCESS         IIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C6
get CID
EXTPORT=(EXTPORT and &HF9)or CID:SYS SYSTEM:pulse STROBE:put READY:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII   IRCOMM ACCESS       IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C7  'TRANSMIT
get HBYTE:get LBYTE:SUBCMD=0:sys COMNAV:put READY:goto LOOP
#C8  'RECEIVE
SUBCMD=1:SYS COMNAV:put HBYTE:put LBYTE:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII  I/O - ACCESS              IIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#C9  'LEDs 1-4 ON
get CID:get GPR
if GPR=0 then goto C9x
EXTPORT=EXTPORT or CID:SYS SYSTEM:pulse STROBE:put READY:goto LOOP
#C9x  'LEDs 1-4 OFF
EXTPORT=EXTPORT and CID:SYS SYSTEM:pulse STROBE:put READY:goto LOOP
'-----------------------------------------------
#C10   'L1-8 ON
get CID:get GPR
if GPR=0 then goto C10x
LEDPORT=LEDPORT or CID:SYS LED_DRIVE:pulse LSTROBE:put READY:goto LOOP
#C10x  'L1-8 OFF
LEDPORT=LEDPORT and CID:SYS LED_DRIVE:pulse LSTROBE:put READY:goto LOOP
#C11
get CID:get GPR:INWORD= GPR*256+CID:get CID:beep INWORD,CID,0:put READY:goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIII  CCRP 5 CONTROLS           IIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

#C12'CLEAR DISTANCE COUNTER
SUBCMD=3:sys COMNAV:put READY:goto LOOP
#C13'SET RC5
SUBCMD=4:sys COMNAV:LBYTE= HBYTE and &HFC
HBYTE=00:SUBCMD=2:sys COMNAV:put READY:goto LOOP
#C14'SET REC80
SUBCMD=4:sys COMNAV:LBYTE= (HBYTE or &H01)and&HFD
HBYTE=00:SUBCMD=2:sys COMNAV:put READY:goto LOOP
#C15'SET REALTIME CLOCK
get hour:get minute:get second:put READY:goto LOOP
#C16'SEND RTC
put hour:put minute:put second:goto LOOP

'------------------------------------------------
'------- ENTER/EXIT SYSTEM SLEEP MODE  ----------
'------------------------------------------------
#C17'SLEEP
get HR:get MIN:put READY
gosub SUBSYS_PWR_OFF:CC2POWER=off
'------ SYSTEM WAKE TIMER ----------------------
#tst
SEC=0:OLDSEC=second
#WTS
if second = OLDSEC then goto WTS
OLDSEC=second:SEC=SEC+1
if SEC<>60 then goto WTS
SEC=0:MIN=MIN-1:beep 368,1,0
if MIN<>0 then goto WTS
if HR=0 then goto WAKEUP
HR=HR-1:MIN=59:goto WTS
'----- WAKE SYSTEM ----------------------------
#WAKEUP
gosub SUBSYS_PWR_ON:beep 368,5,5:beep 368,5,5:beep 368,5,5:CC2POWER=on
'----- WAITING FOR CC2 IS WAKE BYTE -----------
get HR:put 1:goto LOOP
'-------------------------------------------------
'------------ RESPONSE TEST ----------------------
'-------------------------------------------------
#C18'RESPONSE TEST
put 0:goto LOOP
'---------------------------------------------
'----- DATA SACE/RECALL TO EEPROM ------------
'---------------------------------------------
#C19'READ/WRITE DATA TO EEPROM
get CID
on CID goto CLOSE,WOPEN,ROPEN,FWRITE,FREAD
#CLOSE
close#:put READY:goto LOOP
#WOPEN
open# for write:put READY:goto LOOP
#ROPEN
open# for read:put READY:goto LOOP
#FWRITE
get GPR:get INWORD:INWORD=(INWORD shl 8)+ GPR:print# INWORD:put READY:goto LOOP
#FREAD
input# INWORD:put INWORD:put (INWORD shr 8):goto LOOP
#C20'HOUSEKEEPING DATA
put SYS_VOLTS:put SYS_CURRENT:put CHRG_CURRENT:put READY:goto LOOP
'---------------------------------------------
'--- LEDS AUF DER BASIS ERWEITERUNG  ------
'----------------------------------------------------------------
#SUBSYS_PWR_ON
sdio=on:sclio=on:strobe=off:LSTROBE=off:EXTPORT=(EXTPORT and &HFE)or 8
sys SYSTEM:pulse STROBE:return
#SUBSYS_PWR_OFF
EXTPORT=(EXTPORT and &HF7)or 1:sys SYSTEM:pulse STROBE
deact sdio:deact sclio:return
'---------COM/NAV GERTEREIBER -------------
'                 syscode "p5driv12.s19"
